#include "GuiConstants.au3"
#include "Table.au3"
#include "File.au3"
#Include "Constants.au3"
#include "TableFuncs.au3"
#Include "Register.au3"

Opt("TrayMenuMode",1)

Local $Gui_Ha, $arrTry[5], $ctrlListHA

Global $fIni = _SetIni()

Func _LoadSTP( $aID )
	Local $lFile = FileOpenDialog( "Datei auswhlen...", @ScriptDir, "Stundenplne (*.stp)" )
	If $lFile <> "" Then
		Global $fIni = $lFile
		_TableLoadIni( $aID )
	EndIf
EndFunc

Func _SetIni()
	If $CmdLine[0] > 0 Then
		If FileExists( $CmdLine[1] ) Then 
			Return $CmdLine[1]
		ElseIf FileExists( $CmdLine[2] ) Then
			Return $CmdLine[2]
		EndIf
	Else
		Return "Stundenplan.stp"
	EndIf
EndFunc

Func _InstallNotExistingFiles()
	If Not FileExists( "Stundenplan.ini" ) Then FileInstall( "C:\Dokumente und Einstellungen\Schnubby\Desktop\Stundenplan v1.0\Stundenplan.stp", @ScriptDir & "\Stundenplan.stp" )
	If Not FileExists( "Seamarbl.jpg" ) Then FileInstall( "C:\Dokumente und Einstellungen\Schnubby\Desktop\Stundenplan v1.0\Seamarbl.jpg", @ScriptDir & "\Seamarbl.jpg" )
	If Not FileExists( "Kristall.jpg" ) Then FileInstall( "C:\Dokumente und Einstellungen\Schnubby\Desktop\Stundenplan v1.0\Kristall.jpg", @ScriptDir & "\Kristall.jpg" )
	If Not FileExists( "Readme.txt" ) Then FileInstall( "C:\Dokumente und Einstellungen\Schnubby\Desktop\Stundenplan v1.0\Readme.txt", @ScriptDir & "\Readme.txt" )
	If Not FileExists( "History.txt" ) Then FileInstall( "C:\Dokumente und Einstellungen\Schnubby\Desktop\Stundenplan v1.0\History.txt", @ScriptDir & "\History.txt" )	
EndFunc

Func _UpdateHA( $aID1, $aID2, $aID3, $aID4 )
	$lSec = IniReadSection( $fIni, "Hausaufgaben" )
	If IsArray( $lSec ) Then
		For $lNum = 1 to $lSec[0][0]
			$lSplit = StringSplit( IniRead( $fIni, "Hausaufgaben", $lNum, ",,,,"), "," )
			If $lSplit[1] = GUICtrlRead( $ctrlListHA ) And GUICtrlRead( $ctrlLabelHAAufgabe ) <> GUICtrlRead( $ctrlListHA ) Then
				GUICtrlSetData( $aID1, $lSplit[1] )
				GUICtrlSetData( $aID2, $lSplit[2] )
				GUICtrlSetData( $aID3, $lSplit[3] )
				GUICtrlSetData( $aID4, $lSplit[4] )
			EndIf
		Next	
	EndIf
EndFunc

Func _NewSTP()
	GUISetState( @SW_DISABLE, $Gui )
	GUISetState( @SW_SHOW, $Gui_Zeiten )
EndFunc

Func _DelHA()
	$lRead = GUICtrlRead( $ctrlListHA )
	$lSec = IniReadSection( $fIni, "Hausaufgaben" )
	If Not IsArray( $lSec ) Then Return 0
	For $lNum = 1 to $lSec[0][0]
		$lDo = StringSplit( $lSec[$lNum][1], "," )
		If $lDo[1] = $lRead Then
			IniDelete( $fIni, "Hausaufgaben", $lSec[$lNum][0] )
		EndIf
	Next
EndFunc

Func _LoadHaFromIni( $aIni, $aIDList)
	GUICtrlSetData( $aIDList, "")
	$lSec = IniReadSection( $aIni, "Hausaufgaben" )
	If Not IsArray( $lSec ) Then Return 0
	For $lNum = 1 to $lSec[0][0]
		$lSplit = StringSplit( IniRead( $fIni, "Hausaufgaben", $lSec[$lNum][0], ",,,,"), "," )
		GUICtrlSetData( $aIDList, $lSplit[1] )
	Next
EndFunc

Func _WriteHAtoIni( $aIni, $aArr, $aId )
	$lSec = IniReadSection( $aIni, "Hausaufgaben" )
	If Not IsArray( $lSec ) Then 
		IniWrite( $aIni, "Hausaufgaben", 1, $aArr[1] & "," & $aArr[0] & "," & $aArr[2] & "," & $aArr[3] )
		GUISetState( @SW_HIDE, $Gui_Ha )
		_LoadHaFromIni( $aIni, $aID )
		Return 0
	EndIf
	For $lNum = 1 to $lSec[0][0]
		If $lNum < $lSec[$lNum][0] Then
			IniWrite( $aIni, "Hausaufgaben", $lNum, $aArr[1] & "," & $aArr[0] & "," & $aArr[2] & "," & $aArr[3] )
		EndIf
	Next
	$lSecc = IniReadSection( $aIni, "Hausaufgaben" )
	If $lSecc[0][0] = $lSec[0][0] Then
		IniWrite( $aIni, "Hausaufgaben", $lSec[0][0] + 1, $aArr[1] & "," & $aArr[0] & "," & $aArr[2] & "," & $aArr[3] )
	EndIf
	_LoadHaFromIni( $aIni, $aID )
	GUISetState( @SW_HIDE, $Gui_Ha )
EndFunc

Func _OpenUrlInDefaultBrowser( $aUrl )
	$lFile = FileOpen(@TEMPDir & "url.url",2)
	if $lFile = -1 Then Return 0
	FileWriteLine($lFile, "[InternetShortcut]")
	FileWriteLine($lFile, "URL=" & $aUrl)
	FileClose($lFile)
	Run(@comspec & " /c " & chr(34) & @TEMPDir & "url.url" & chr(34), "", @SW_HIDE)
	Return 1
EndFunc

Func _NewHa( )
	GUISetState( @SW_SHOW, $Gui_Ha )
	For $lNum = 0 to 3
		GUICtrlSetData( $arrTry[$lNum], "" )
	Next
	; Inputs leeren
EndFunc

Func _ListViewRead( $aID )
	Return GUICtrlRead( GUICtrlRead( $aID ) )
EndFunc

Func _About()
	MsgBox( 0, "", "Autor: Daniel Wahlmann" & @CRLF & "Thx an www.autoit.de", 5)
EndFunc

Func _GuiCtrlCreateHyperlink($S_TEXT, $I_LEFT, $I_TOP, _
        $I_WIDTH = -1, $I_HEIGHT = -1, $I_COLOR =  0x00AABB, $S_TOOLTIP = '', $I_STYLE = -1, $I_EXSTYLE = -1)
   Local $I_CTRLID
   $I_CTRLID = GUICtrlCreateLabel($S_TEXT, $I_LEFT, $I_TOP, $I_WIDTH, $I_HEIGHT, $I_STYLE, $I_EXSTYLE)
   If $I_CTRLID <> 0 Then
      GUICtrlSetFont($I_CTRLID, -1, -1, 4)
      GUICtrlSetColor($I_CTRLID, $I_COLOR)
      GUICtrlSetCursor($I_CTRLID, 0)
      If $S_TOOLTIP <> '' Then
         GUICtrlSetTip($I_CTRLID, $S_TOOLTIP)
      EndIf
   EndIf
   Return $I_CTRLID
EndFunc

Func _WriteToIni()
	IniDelete( $fIni, "Zeiten" )
	IniDelete( $fIni, "Montag" )
	IniDelete( $fIni, "Dienstag" )
	IniDelete( $fIni, "Mittwoch" )
	IniDelete( $fIni, "Freitag" )
	IniDelete( $fIni, "Donnerstag" )
	For $lNumY = 1 to 8
		IniWrite( $fIni, "Montag", $lNumY, GUICtrlRead( $ctrlEdit_Montag[1][$lNumY] )  & "," & GUICtrlRead( $ctrlEdit_Montag[2][$lNumY] ) & "," & GUICtrlRead( $ctrlEdit_Montag[3][$lNumY] ))
		IniWrite( $fIni, "Dienstag", $lNumY, GUICtrlRead( $ctrlEdit_Dienstag[1][$lNumY]) & "," & GUICtrlRead( $ctrlEdit_Dienstag[2][$lNumY] ) & "," & GUICtrlRead( $ctrlEdit_Dienstag[3][$lNumY] ))
		IniWrite( $fIni, "Mittwoch", $lNumY, GUICtrlRead( $ctrlEdit_Mittwoch[1][$lNumY]) & "," & GUICtrlRead( $ctrlEdit_Mittwoch[2][$lNumY] ) & "," & GUICtrlRead( $ctrlEdit_Mittwoch[3][$lNumY] ))
		IniWrite( $fIni, "Donnerstag", $lNumY, GUICtrlRead( $ctrlEdit_Donnerstag[1][$lNumY]) & "," & GUICtrlRead( $ctrlEdit_Donnerstag[2][$lNumY] ) & "," &GUICtrlRead(  $ctrlEdit_Donnerstag[3][$lNumY] ))
		IniWrite( $fIni, "Freitag", $lNumY, GUICtrlRead( $ctrlEdit_Freitag[1][$lNumY]) & "," & GUICtrlRead( $ctrlEdit_Freitag[2][$lNumY] ) & "," & GUICtrlRead( $ctrlEdit_Freitag[3][$lNumY] ))
	Next
	GUISetState( @SW_HIDE, $Gui_Freitag )
	_TableLoadIni( $Table )
EndFunc

Func _TableLoadIni( $Table )

Global $arZeile1[10] = [ "Zeit", "1. Stunde", "2. Stunde", "3. Stunde", "4. Stunde", "5. Stunde", "6. Stunde", "7. Stunde", "8. Stunde"]
Global $arTipZeile1[10] = [ "", _
							IniRead( $fIni, "Zeiten", "1", "8.00 - 8.45" ), _
							IniRead( $fIni, "Zeiten", "2", "8.50 - 9.35" ), _
							IniRead( $fIni, "Zeiten", "3", "9.55 - 10.40" ), _
							IniRead( $fIni, "Zeiten", "4", "10.45 - 11.30" ), _
							IniRead( $fIni, "Zeiten", "5", "11.50 - 12.35" ), _
							IniRead( $fIni, "Zeiten", "6", "12.40 - 13.25" ), _
							IniRead( $fIni, "Zeiten", "7", "14.00 - 14.45" ), _
							IniRead( $fIni, "Zeiten", "8", "14.50 - 15.35" ) ]

Local $lEins = StringSplit( IniRead( $fIni, "Montag", "1", ",,,,"), "," )
Local $lZwei = StringSplit( IniRead( $fIni, "Montag", "2", ",,,,"), "," )
Local $lDrei = StringSplit( IniRead( $fIni, "Montag", "3", ",,,,"), "," )
Local $lVier = StringSplit( IniRead( $fIni, "Montag", "4", ",,,,"), "," )
Local $lFunf = StringSplit( IniRead( $fIni, "Montag", "5", ",,,,"), "," )
Local $lSechs = StringSplit( IniRead( $fIni, "Montag", "6", ",,,,"), "," )
Local $lSieben = StringSplit( IniRead( $fIni, "Montag", "7", ",,,,"), "," )
Local $lAcht = StringSplit( IniRead( $fIni, "Montag", "8", ",,,,"), "," )
Global $arZeile2[10] = [ "Montag", $lEins[1], $lZwei[1], $lDrei[1], $lVier[1], $lFunf[1], $lSechs[1], $lSieben[1], $lAcht[1]]
Global $arTipZeile2[10] = [ "", _
							"Lehrer: " & $lEins[2] & @CRLF & "Raum: " & $lEins[3], _
							"Lehrer: " & $lZwei[2] & @CRLF & "Raum: " & $lZwei[3], _
							"Lehrer: " & $lDrei[2] & @CRLF & "Raum: " & $lDrei[3], _
							"Lehrer: " & $lVier[2] & @CRLF & "Raum: " & $lVier[3], _
							"Lehrer: " & $lFunf[2] & @CRLF & "Raum: " & $lFunf[3], _
							"Lehrer: " & $lSechs[2] & @CRLF & "Raum: " & $lSechs[3], _
							"Lehrer: " & $lSieben[2] & @CRLF & "Raum: " & $lSieben[3], _
							"Lehrer: " & $lAcht[2] & @CRLF & "Raum: " & $lAcht[3]]
							
Local $lEins = StringSplit( IniRead( $fIni, "Dienstag", "1", ",,,,"), "," )
Local $lZwei = StringSplit( IniRead( $fIni, "Dienstag", "2", ",,,,"), "," )
Local $lDrei = StringSplit( IniRead( $fIni, "Dienstag", "3", ",,,,"), "," )
Local $lVier = StringSplit( IniRead( $fIni, "Dienstag", "4", ",,,,"), "," )
Local $lFunf = StringSplit( IniRead( $fIni, "Dienstag", "5", ",,,,"), "," )
Local $lSechs = StringSplit( IniRead( $fIni, "Dienstag", "6", ",,,,"), "," )
Local $lSieben = StringSplit( IniRead( $fIni, "Dienstag", "7", ",,,,"), "," )
Local $lAcht = StringSplit( IniRead( $fIni, "Dienstag", "8", ",,,,"), "," )
Global $arZeile3[10] = [ "Dienstag", $lEins[1], $lZwei[1], $lDrei[1], $lVier[1], $lFunf[1], $lSechs[1], $lSieben[1], $lAcht[1]]
Global $arTipZeile3[10] = [ "", _
							"Lehrer: " & $lEins[2] & @CRLF & "Raum: " & $lEins[3], _
							"Lehrer: " & $lZwei[2] & @CRLF & "Raum: " & $lZwei[3], _
							"Lehrer: " & $lDrei[2] & @CRLF & "Raum: " & $lDrei[3], _
							"Lehrer: " & $lVier[2] & @CRLF & "Raum: " & $lVier[3], _
							"Lehrer: " & $lFunf[2] & @CRLF & "Raum: " & $lFunf[3], _
							"Lehrer: " & $lSechs[2] & @CRLF & "Raum: " & $lSechs[3], _
							"Lehrer: " & $lSieben[2] & @CRLF & "Raum: " & $lSieben[3], _
							"Lehrer: " & $lAcht[2] & @CRLF & "Raum: " & $lAcht[3]]

Local $lEins = StringSplit( IniRead( $fIni, "Mittwoch", "1", ",,,,"), "," )
Local $lZwei = StringSplit( IniRead( $fIni, "Mittwoch", "2", ",,,,"), "," )
Local $lDrei = StringSplit( IniRead( $fIni, "Mittwoch", "3", ",,,,"), "," )
Local $lVier = StringSplit( IniRead( $fIni, "Mittwoch", "4", ",,,,"), "," )
Local $lFunf = StringSplit( IniRead( $fIni, "Mittwoch", "5", ",,,,"), "," )
Local $lSechs = StringSplit( IniRead( $fIni, "Mittwoch", "6", ",,,,"), "," )
Local $lSieben = StringSplit( IniRead( $fIni, "Mittwoch", "7", ",,,,"), "," )
Local $lAcht = StringSplit( IniRead( $fIni, "Mittwoch", "8", ",,,,"), "," )
Global $arZeile4[10] = [ "Mittwoch", $lEins[1], $lZwei[1], $lDrei[1], $lVier[1], $lFunf[1], $lSechs[1], $lSieben[1], $lAcht[1]]
Global $arTipZeile4[10] = [ "", _
							"Lehrer: " & $lEins[2] & @CRLF & "Raum: " & $lEins[3], _
							"Lehrer: " & $lZwei[2] & @CRLF & "Raum: " & $lZwei[3], _
							"Lehrer: " & $lDrei[2] & @CRLF & "Raum: " & $lDrei[3], _
							"Lehrer: " & $lVier[2] & @CRLF & "Raum: " & $lVier[3], _
							"Lehrer: " & $lFunf[2] & @CRLF & "Raum: " & $lFunf[3], _
							"Lehrer: " & $lSechs[2] & @CRLF & "Raum: " & $lSechs[3], _
							"Lehrer: " & $lSieben[2] & @CRLF & "Raum: " & $lSieben[3], _
							"Lehrer: " & $lAcht[2] & @CRLF & "Raum: " & $lAcht[3]]

Local $lEins = StringSplit( IniRead( $fIni, "Donnerstag", "1", ",,,,"), "," )
Local $lZwei = StringSplit( IniRead( $fIni, "Donnerstag", "2", ",,,,"), "," )
Local $lDrei = StringSplit( IniRead( $fIni, "Donnerstag", "3", ",,,,"), "," )
Local $lVier = StringSplit( IniRead( $fIni, "Donnerstag", "4", ",,,,"), "," )
Local $lFunf = StringSplit( IniRead( $fIni, "Donnerstag", "5", ",,,,"), "," )
Local $lSechs = StringSplit( IniRead( $fIni, "Donnerstag", "6", ",,,,"), "," )
Local $lSieben = StringSplit( IniRead( $fIni, "Donnerstag", "7", ",,,,"), "," )
Local $lAcht = StringSplit( IniRead( $fIni, "Donnerstag", "8", ",,,,"), "," )
Global $arZeile5[10] = [ "Donnerstag", $lEins[1], $lZwei[1], $lDrei[1], $lVier[1], $lFunf[1], $lSechs[1], $lSieben[1], $lAcht[1]]
Global $arTipZeile5[10] = [ "", _
							"Lehrer: " & $lEins[2] & @CRLF & "Raum: " & $lEins[3], _
							"Lehrer: " & $lZwei[2] & @CRLF & "Raum: " & $lZwei[3], _
							"Lehrer: " & $lDrei[2] & @CRLF & "Raum: " & $lDrei[3], _
							"Lehrer: " & $lVier[2] & @CRLF & "Raum: " & $lVier[3], _
							"Lehrer: " & $lFunf[2] & @CRLF & "Raum: " & $lFunf[3], _
							"Lehrer: " & $lSechs[2] & @CRLF & "Raum: " & $lSechs[3], _
							"Lehrer: " & $lSieben[2] & @CRLF & "Raum: " & $lSieben[3], _
							"Lehrer: " & $lAcht[2] & @CRLF & "Raum: " & $lAcht[3]]

Local $lEins = StringSplit( IniRead( $fIni, "Freitag", "1", ",,,,"), "," )
Local $lZwei = StringSplit( IniRead( $fIni, "Freitag", "2", ",,,,"), "," )
Local $lDrei = StringSplit( IniRead( $fIni, "Freitag", "3", ",,,,"), "," )
Local $lVier = StringSplit( IniRead( $fIni, "Freitag", "4", ",,,,"), "," )
Local $lFunf = StringSplit( IniRead( $fIni, "Freitag", "5", ",,,,"), "," )
Local $lSechs = StringSplit( IniRead( $fIni, "Freitag", "6", ",,,,"), "," )
Local $lSieben = StringSplit( IniRead( $fIni, "Freitag", "7", ",,,,"), "," )
Local $lAcht = StringSplit( IniRead( $fIni, "Freitag", "8", ",,,,"), "," )
Global $arZeile6[10] = [ "Freitag", $lEins[1], $lZwei[1], $lDrei[1], $lVier[1], $lFunf[1], $lSechs[1], $lSieben[1], $lAcht[1]]
Global $arTipZeile6[10] = [ "", _
							"Lehrer: " & $lEins[2] & @CRLF & "Raum: " & $lEins[3], _
							"Lehrer: " & $lZwei[2] & @CRLF & "Raum: " & $lZwei[3], _
							"Lehrer: " & $lDrei[2] & @CRLF & "Raum: " & $lDrei[3], _
							"Lehrer: " & $lVier[2] & @CRLF & "Raum: " & $lVier[3], _
							"Lehrer: " & $lFunf[2] & @CRLF & "Raum: " & $lFunf[3], _
							"Lehrer: " & $lSechs[2] & @CRLF & "Raum: " & $lSechs[3], _
							"Lehrer: " & $lSieben[2] & @CRLF & "Raum: " & $lSieben[3], _
							"Lehrer: " & $lAcht[2] & @CRLF & "Raum: " & $lAcht[3]]
							
	For $lNum = 0 to 8
		For $lNumb = 1 to 6
			_TableSetBkColor( $Table, $GUI_BKCOLOR_TRANSPARENT, $lNumb, $lNum + 1)
			_TableSetFont( $Table, $lNumb, $lNum + 1, 9, 5000, Default, "Courier New")
		Next
		_TableSetTip( $Table, $arTipZeile1[$lNum], 1, $lNum + 1)
		_TableSetTip( $Table, $arTipZeile2[$lNum], 2, $lNum + 1)
		_TableSetTip( $Table, $arTipZeile3[$lNum], 3, $lNum + 1)
		_TableSetTip( $Table, $arTipZeile4[$lNum], 4, $lNum + 1)
		_TableSetTip( $Table, $arTipZeile5[$lNum], 5, $lNum + 1)
		_TableSetTip( $Table, $arTipZeile6[$lNum], 6, $lNum + 1)
		_TableSetData( $Table, $arZeile1[$lNum], 1, $lNum + 1)
		_TableSetData( $Table, $arZeile2[$lNum], 2, $lNum + 1)
		_TableSetData( $Table, $arZeile3[$lNum], 3, $lNum + 1)
		_TableSetData( $Table, $arZeile4[$lNum], 4, $lNum + 1)
		_TableSetData( $Table, $arZeile5[$lNum], 5, $lNum + 1)
		_TableSetData( $Table, $arZeile6[$lNum], 6, $lNum + 1)
		If Not _TableGetData( $Table, @WDAY, $lNum + 1) = "" Then
			If @WDAY > 1 Then 
				_TableSetBkColor( $Table,  0x00AAFF, @WDAY, $lNum + 1)
				_TableSetColor( $Table, 0xFFFFFF, @WDAY, $lNum + 1)
			EndIf
		EndIf
	Next
EndFunc							