;===============================================================================
;
; Description:      Verknpft Dateierweiterung mit Anwendung
; Parameter(s):     $sFileType    = Dateierweiterung
;                   $sDescription = Beschreibung fr die Datei
;                   (optional) $sAppName = Anwendung fr die Registriert werden
;                                          soll, wird keine Anwendung angegeben
;                                          wird die aktuelle Anwendung eingetragen
; Requirement(s):   keine
; Return Value(s):  bei Erfolg: 1
;                   bei Fehler: 0 und @error = 1
; Author(s):        bernd670
;
;===============================================================================
Func _RegisterFileType($sFileType, $sDescription, $sAppName = "")
        Dim $sTypeName
        
        If $sFileType = "" Or $sDescription = "" Then
                SetError(1)
                Return 0
        EndIf
        
        If $sAppName = "" Then $sAppName = @ScriptFullPath
        
        $sFileType = StringLower($sFileType)
        
        If StringLeft($sFileType, 1) <> "." Then
                $sTypeName = $sFileType
                $sFileType = "." & $sFileType
        Else
                $sTypeName = StringRight($sFileType, StringLen($sFileType) - 1)
        EndIf
        
        $sTypeName = $sTypeName & "file"
        
        RegWrite("HKCR\" & $sFileType, "", "REG_SZ", $sTypeName)
        RegWrite("HKCR\" & $sTypeName, "", "REG_SZ", $sDescription)
        RegWrite("HKCR\" & $sTypeName & "\shell\open\command", "", "REG_SZ", $sAppName & " -cal %1")
        RegWrite("HKCR\" & $sTypeName & "\DefaultIcon", "", "REG_SZ", $sAppName & ",0")
        
        SetError(0)
        Return 1
EndFunc   ;==>_RegisterFileType


;===============================================================================
;
; Description:      Hebt Verknpfung einer Dateierweiterung mit Anwendung auf
; Parameter(s):     $sFileType    = Dateierweiterung
; Requirement(s):   keine
; Return Value(s):  bei Erfolg: 1
;                   bei Fehler: 0 und @error = 1
; Author(s):        bernd670
;
;===============================================================================
Func _UnRegisterFileType($sFileType)
        Dim $sTypeName
        
        If $sFileType = "" Then
                SetError(1)
                Return 0
        EndIf
        
        $sFileType = StringLower($sFileType)
        
        If StringLeft($sFileType, 1) <> "." Then
                $sTypeName = $sFileType
                $sFileType = "." & $sFileType
        Else
                $sTypeName = StringRight($sFileType, StringLen($sFileType) - 1)
        EndIf
        
        $sTypeName = $sTypeName & "file"
        
        RegDelete("HKEY_CLASSES_ROOT\" & $sFileType)
        RegDelete("HKEY_CLASSES_ROOT\" & $sTypeName)
        
        SetError(0)
        Return 1
EndFunc   ;==>_UnRegisterFileType 