; ----------------------------------------------------------------------------
;
; AutoIt Version: 3.2.1.9
; Author:         Daniel Wahlmann <danielwahlmann@web.de>
;
; ----------------------------------------------------------------------------
;~ 


#NoTrayIcon
#include "Header.au3"
; ^ = Strg ! = Alt
HotKeySet( "^{F7}", "_About" )
HotKeySet( "^{F5}", "_NewHA" )
HotKeySet( "^{F6}", "_NewSTP" )
HotKeySet( "{DEL}", "_DelHA" )

_InstallNotExistingFiles()

Global $fIni = _SetIni()
Global Const $Version = "v1.0"
Global Const $WinExists = 1
Global Const $WinVisible = 2
Global Const $WinEnabled = 4
Global Const $WinActive = 8
Global Const $WinMinimized = 16
Global Const $WinMaximized = 32
Global $ctrlEdit[9] 
Global $ctrlEdit_Montag[4][9]
Global $ctrlEdit_Dienstag[4][9]
Global $ctrlEdit_Mittwoch[4][9]
Global $ctrlEdit_Donnerstag[4][9]
Global $ctrlEdit_Freitag[4][9]
Global $arrText[5] = [ "", "Fach", "Lehrer", "Raum" ]

_RegisterFileType( ".stp", "Stundenplan " & $Version )

#region Hauptfenster
$Gui = GUICreate( "Stundenplan " & $Version, 825, 470, Default, Default, Default, Default )

GUICtrlCreatePic( "Seamarbl.jpg", 0, 0, 825, 450)
GUICtrlSetState( -1, $GUI_DISABLE )

$ctrlGroupTable = GUICtrlCreateGroup( "", 10, 10, 495, 280 )
GUICtrlSetFont( $ctrlGroupTable, 10 )
$Table = _GuiCtrlCreateTable( 28, 35, 6, 9, 75, 25)

_TableLoadIni( $Table )

$ctrlGroupAbout = GUICtrlCreateGroup( "" , 520, 10, 290 , 150)
$ctrlLabelAbout = GUICtrlCreateLabel( "Stundenplan " & $Version & @CRLF & "by Daniel W.", 540, 30, 250, 50 )
GUICtrlSetBkColor( -1, $GUI_BKCOLOR_TRANSPARENT)
GUICtrlSetFont( $ctrlLabelAbout, 14 )
$ctrlLinkGZE = _GuiCtrlCreateHyperlink( "Besucht die Homepage des GZE", 540, 90, 190, 20 )
GUICtrlSetBkColor( -1, $GUI_BKCOLOR_TRANSPARENT)
$ctrlLinkVersion = _GuiCtrlCreateHyperlink( "Die neueste Version gibt es hier!", 540, 120, 190, 20)
GUICtrlSetBkColor( -1, $GUI_BKCOLOR_TRANSPARENT)

$ctrlGroupHAInfo = GUICtrlCreateGroup( "", 520, 170, 290, 265 )
$ctrlLabelHAAbout = GUICtrlCreateLabel( "Hausaufgaben Details", 575, 193, 300, 200 )
GUICtrlSetFont( $ctrlLabelHAAbout, 10, 5000, 4)
GUICtrlSetBkColor( $ctrlLabelHAAbout, $GUI_BKCOLOR_TRANSPARENT )
GUICtrlCreateLabel( "Fach:", 540, 240)
GUICtrlSetFont( -1, 9, 5000, 4)
GUICtrlSetBkColor( -1, $GUI_BKCOLOR_TRANSPARENT )
$ctrlLabelHAFach = GUICtrlCreateLabel( "", 650, 240, 100, 15)
GUICtrlSetBkColor( -1, $GUI_BKCOLOR_TRANSPARENT )
GUICtrlCreateLabel( "Aufgabe:", 540, 270)
GUICtrlSetFont( -1, 9, 5000, 4)
GUICtrlSetBkColor( -1, $GUI_BKCOLOR_TRANSPARENT )
$ctrlLabelHAAufgabe = GUICtrlCreateLabel( "", 650, 270, 100, 15)
GUICtrlSetBkColor( -1, $GUI_BKCOLOR_TRANSPARENT )
GUICtrlCreateLabel( "Von:", 540, 300)
GUICtrlSetFont( -1, 9, 5000, 4)
GUICtrlSetBkColor( -1, $GUI_BKCOLOR_TRANSPARENT )
$ctrlLabelHAVon = GUICtrlCreateLabel( "", 650, 300, 100, 15)
GUICtrlSetBkColor( -1, $GUI_BKCOLOR_TRANSPARENT )
GUICtrlCreateLabel( "Bis:", 540, 330)
GUICtrlSetFont( -1, 9, 5000, 4)
GUICtrlSetBkColor( -1, $GUI_BKCOLOR_TRANSPARENT )
$ctrlLabelHABis = GUICtrlCreateLabel( "", 650, 330, 100, 15)
GUICtrlSetBkColor( -1, $GUI_BKCOLOR_TRANSPARENT )

$ctrlGroupHA = GUICtrlCreateGroup( "", 10, 300, 495, 135 )
$ctrlListHA = GUICtrlCreateList( "", 28, 323, 455, 100)
_LoadHaFromIni( $fIni, $ctrlListHA)

$ctrlMenuEdit = GUICtrlCreateMenu( "Edit" )

$ctrlMenuEdit_LoadSTP = GUICtrlCreateMenuitem( "Stundenplan ffnen", $ctrlMenuEdit )

GUICtrlCreateMenuitem( "", $ctrlMenuEdit )

$ctrlMenuEdit_NewHA = GUICtrlCreateMenuitem( "Neue Hausaufgabe   Strg+F5", $ctrlMenuEdit )
$ctrlMenuEdit_NewSTP = GUICtrlCreateMenuitem( "Neuer Stundenplan  Strg+F6", $ctrlMenuEdit )

GUICtrlCreateMenuitem( "", $ctrlMenuEdit )
$ctrlMenuEdit_Open = GUICtrlCreateMenu( "ffnen", $ctrlMenuEdit )
$ctrlMenuEdit_Open_Readme = GUICtrlCreateMenuitem( "Readme.txt", $ctrlMenuEdit_Open )
$ctrlMenuEdit_Open_History = GUICtrlCreateMenuitem( "History.txt", $ctrlMenuEdit_Open )
GUICtrlCreateMenuitem( "", $ctrlMenuEdit )
$ctrlMenuEdit_About = GUICtrlCreateMenuitem( "About                        Strg+F7", $ctrlMenuEdit )
$ctrlMenuEdit_Exit =  GUICtrlCreateMenuitem( "Beenden                    Alt+F4", $ctrlMenuEdit )

GUISetState()
#endregion

#region Gui - Neuer Stundenplan - Zeiten
;Zeiten
$Gui_Zeiten = GUICreate( "Neuer Stundenplan", 400, 335 )

$ctrlHeader = GUICtrlCreateLabel( "Zeiten", 150, 10, 100, 20 )
GUICtrlSetFont( $ctrlHeader, 11, 1000, 4 )
For $lNum = 1 to 8
	GUICtrlCreateLabel( $lNum & ". Stunde:", 20, 10 + $lNum * 30 )
	$ctrlEdit[$lNum] = GUICtrlCreateEdit( IniRead( "Stundenplan.ini", "Zeiten", $lNum, $lNum ), 125, 10 + $lNum * 30, 250 )
Next
$ctrlButton = GUICtrlCreateButton( "Next >", 150, 280, 100, 30 )
#endregion

#region Gui - Neuer Stundenplan - Montag
;Montag
$Gui_Montag = GUICreate( "Neuer Stundenplan", 400, 335 )

$ctrlGuiMontag_Header = GUICtrlCreateLabel( "Montag", 150, 10, 100, 20 )
GUICtrlSetFont( $ctrlGuiMontag_Header, 11, 1000, 4 )
For $lNumX = 1 to 3
	GUICtrlCreateLabel( $arrText[$lNumX], 100 + ($lNumX - 1) * 90, 40 )
	For $lNumY = 1 to 8
		$lSplit = StringSplit( IniRead( "Stundenplan.ini", "Montag", $lNumY, ",," ), "," )
		$ctrlEdit_Montag[$lNumX][$lNumY] = GUICtrlCreateEdit( $lSplit[$lNumX], 100 + ($lNumX - 1) * 90, 30 + $lNumY * 30, 80 )
	Next
Next
For $lNum = 1 to 8
	GUICtrlCreateLabel( $lNum & ". Stunde:", 20, 30 + $lNum * 30 )
Next
$ctrlButton_Montag_Back = GUICtrlCreateButton( "< Zeiten", 75, 300, 100, 30 )
$ctrlButton_Montag_Next = GUICtrlCreateButton( "Dienstag >", 200, 300, 100, 30 )
#endregion

#region Gui - Neuer Stundenplan - Dienstag
;Dienstag
$Gui_Dienstag = GUICreate( "Neuer Stundenplan", 400, 335 )

$ctrlGuiDienstag_Header = GUICtrlCreateLabel( "Dienstag", 150, 10, 100, 20 )
GUICtrlSetFont( $ctrlGuiDienstag_Header, 11, 1000, 4 )
For $lNumX = 1 to 3
	GUICtrlCreateLabel( $arrText[$lNumX], 100 + ($lNumX - 1) * 90, 40 )
	For $lNumY = 1 to 8
		$lSplit = StringSplit( IniRead( "Stundenplan.ini", "Dienstag", $lNumY, ",," ), "," )
		$ctrlEdit_Dienstag[$lNumX][$lNumY] = GUICtrlCreateEdit( $lSplit[$lNumX], 100 + ($lNumX - 1) * 90, 30 + $lNumY * 30, 80 )
	Next
Next
For $lNum = 1 to 8
	GUICtrlCreateLabel( $lNum & ". Stunde:", 20, 30 + $lNum * 30 )
Next
$ctrlButton_Dienstag_Back = GUICtrlCreateButton( "< Montag", 75, 300, 100, 30 )
$ctrlButton_Dienstag_Next = GUICtrlCreateButton( "Mittwoch >", 200, 300, 100, 30 )
#endregion

#region Gui - Neuer Stundenplan - Mittwoch
;Mittwoch
$Gui_Mittwoch = GUICreate( "Neuer Stundenplan", 400, 335 )

$ctrlGuiMittwoch_Header = GUICtrlCreateLabel( "Mittwoch", 150, 10, 100, 20 )
GUICtrlSetFont( $ctrlGuiMittwoch_Header, 11, 1000, 4 )
For $lNumX = 1 to 3
	GUICtrlCreateLabel( $arrText[$lNumX], 100 + ($lNumX - 1) * 90, 40 )
	For $lNumY = 1 to 8
		$lSplit = StringSplit( IniRead( "Stundenplan.ini", "Mittwoch", $lNumY, ",," ), "," )
		$ctrlEdit_Mittwoch[$lNumX][$lNumY] = GUICtrlCreateEdit( $lSplit[$lNumX], 100 + ($lNumX - 1) * 90, 30 + $lNumY * 30, 80 )
	Next
Next
For $lNum = 1 to 8
	GUICtrlCreateLabel( $lNum & ". Stunde:", 20, 30 + $lNum * 30 )
Next
$ctrlButton_Mittwoch_Back = GUICtrlCreateButton( "< Dienstag", 75, 300, 100, 30 )
$ctrlButton_Mittwoch_Next = GUICtrlCreateButton( "Donnerstag >", 200, 300, 100, 30 )
#endregion

#region Gui - Neuer Stundenplan - Donnerstag
;Donnerstag
$Gui_Donnerstag = GUICreate( "Neuer Stundenplan", 400, 335 )

$ctrlGuiDonnerstag_Header = GUICtrlCreateLabel( "Donnerstag", 150, 10, 100, 20 )
GUICtrlSetFont( $ctrlGuiDonnerstag_Header, 11, 1000, 4 )
For $lNumX = 1 to 3
	GUICtrlCreateLabel( $arrText[$lNumX], 100 + ($lNumX - 1) * 90, 40 )
	For $lNumY = 1 to 8
		$lSplit = StringSplit( IniRead( "Stundenplan.ini", "Donnerstag", $lNumY, ",," ), "," )
		$ctrlEdit_Donnerstag[$lNumX][$lNumY] = GUICtrlCreateEdit( $lSplit[$lNumX], 100 + ($lNumX - 1) * 90, 30 + $lNumY * 30, 80 )
	Next
Next
For $lNum = 1 to 8
	GUICtrlCreateLabel( $lNum & ". Stunde:", 20, 30 + $lNum * 30 )
Next
$ctrlButton_Donnerstag_Back = GUICtrlCreateButton( "< Mittwoch", 75, 300, 100, 30 )
$ctrlButton_Donnerstag_Next = GUICtrlCreateButton( "Freitag >", 200, 300, 100, 30 )
#endregion

#region Gui - Neuer Stundenplan - Freitag
;Freitag
$Gui_Freitag = GUICreate( "Neuer Stundenplan", 400, 335 )

$ctrlFreitag_Header = GUICtrlCreateLabel( "Freitag", 150, 10, 100, 20 )
GUICtrlSetFont( $ctrlFreitag_Header, 11, 1000, 4 )
For $lNumX = 1 to 3
	GUICtrlCreateLabel( $arrText[$lNumX], 100 + ($lNumX - 1) * 90, 40 )
	For $lNumY = 1 to 8
		$lSplit = StringSplit( IniRead( "Stundenplan.ini", "Freitag", $lNumY, ",," ), "," )
		$ctrlEdit_Freitag[$lNumX][$lNumY] = GUICtrlCreateEdit( $lSplit[$lNumX], 100 + ($lNumX - 1) * 90, 30 + $lNumY * 30, 80 )
	Next
Next
For $lNum = 1 to 8
	GUICtrlCreateLabel( $lNum & ". Stunde:", 20, 30 + $lNum * 30 )
Next
$ctrlButton_Freitag_Back = GUICtrlCreateButton( "< Donnerstag", 75, 300, 100, 30 )
$ctrlButton_Freitag_Next = GUICtrlCreateButton( "Fertig", 200, 300, 100, 30 )
#endregion

#region Gui - Neue Hausaufgabe
$Gui_HA = GuiCreate( "Neue Hausaufgabe", 300, 300, Default, Default, Default, Default, $GUI )

GUICtrlCreatePic( "Kristall.jpg", 0, 0, 300, 300)
GUICtrlSetState( -1, $GUI_DISABLE )
GUICtrlCreateLabel( "Neue Hausaufgabe", 75, 10, 200, 15)
GUICtrlSetBkColor( -1, $GUI_BKCOLOR_TRANSPARENT )
GUICtrlSetFont( -1, 10, 5000, 4)

Local $arrTry[5] = ["Fach:", "Aufgabe:", "Von:", "Bis:"]

For $lNum = 0 to 3
	GUICtrlCreateLabel( $arrTry[$lNum], 25, 70 + ( 40 * $lNum ), 100)
	GUICtrlSetBkColor( -1, $GUI_BKCOLOR_TRANSPARENT )
	GUICtrlSetFont( -1, 9, 5000, 4)
Next
Local $arrTry[5]
For $lNum = 0 to 3
	$arrTry[$lNum] = GUICtrlCreateInput( "", 150, 70 + ( 40 * $lNum ), 100)
	GUICtrlSetBkColor( -1, $GUI_BKCOLOR_TRANSPARENT )
Next
$ctrlButtonOK = GUICtrlCreateButton( "OK", 50, 240, 75 )
$ctrlButtonCancel = GUICtrlCreateButton( "Cancel", 175, 240, 75 )
#endregion

#region Traymenu
$trayItem_Show = TrayCreateItem( "Stundenplan anzeigen" )
TrayCreateItem("")
$trayItem_NewHA = TrayCreateItem("Neue Hausaufgabe")
TrayCreateItem("")
$trayMenu_Open = TrayCreateMenu("ffnen")
$trayMenu_Open_Readme = TrayCreateItem( "Readme.txt", $trayMenu_Open ) 
$trayMenu_Open_History = TrayCreateItem( "History.txt", $trayMenu_Open)
TrayCreateItem("")
$trayItem_About = TrayCreateItem("About")
$trayItem_Exit = TrayCreateItem("Exit")
TraySetIcon( "Stundenplan.ico" )
TraySetToolTip("Stundenplan")
#endregion

WinActivate( "Stundenplan " & $Version )

While 1
	$tMsg = TrayGetMsg()
	Switch $tMsg
		Case $trayMenu_Open_Readme
			ShellExecute( @ScriptDir & "\Readme.txt" )
		Case $trayMenu_Open_History
			ShellExecute( @ScriptDir & "\History.txt" )
		Case $trayItem_NewHA
			_NewHA()
		Case $trayItem_Exit
			Exit
		Case $trayItem_About
			_About()
		Case $trayItem_Show
			WinActivate( "Stundenplan " & $Version )
	EndSwitch
	$Msg = GUIGetMsg()
	Switch $Msg 
		Case $ctrlButton
			GUISetState( @SW_SHOW, $Gui_Montag )
			GUISetState( @SW_HIDE, $Gui_Zeiten )
		Case $ctrlButton_Montag_Back
			GUISetState( @SW_SHOW, $Gui_Zeiten )
			GUISetState( @SW_HIDE, $Gui_Montag )
		Case $ctrlButton_Montag_Next
			GUISetState( @SW_SHOW, $Gui_Dienstag )
			GUISetState( @SW_HIDE, $Gui_Montag )
		Case $ctrlButton_Dienstag_Back
			GUISetState( @SW_SHOW, $Gui_Montag )
			GUISetState( @SW_HIDE, $Gui_Dienstag )			
		Case $ctrlButton_Dienstag_Next
			GUISetState( @SW_SHOW, $Gui_Mittwoch )
			GUISetState( @SW_HIDE, $Gui_Dienstag )
		Case $ctrlButton_Mittwoch_Back
			GUISetState( @SW_SHOW, $Gui_Dienstag )
			GUISetState( @SW_HIDE, $Gui_Mittwoch )
		Case $ctrlButton_Mittwoch_Next
			GUISetState( @SW_SHOW, $Gui_Donnerstag )
			GUISetState( @SW_HIDE, $Gui_Mittwoch )
		Case $ctrlButton_Donnerstag_Back
			GUISetState( @SW_SHOW, $Gui_Mittwoch )
			GUISetState( @SW_HIDE, $Gui_Donnerstag )
		Case $ctrlButton_Donnerstag_Next
			GUISetState( @SW_SHOW, $Gui_Freitag )
			GUISetState( @SW_HIDE, $Gui_Donnerstag )
		Case $ctrlButton_Freitag_Back
			GUISetState( @SW_SHOW, $Gui_Donnerstag )
			GUISetState( @SW_HIDE, $Gui_Freitag )
		Case $ctrlButton_Freitag_Next
			GUISetState( @SW_ENABLE, $Gui )
			_WriteToIni()
		Case $ctrlMenuEdit_LoadSTP
			_LoadSTP( $Table )
		Case $ctrlMenuEdit_Open_Readme
			ShellExecute( @ScriptDir & "\Readme.txt" )
		Case $ctrlMenuEdit_Open_History
			ShellExecute( @ScriptDir & "\History.txt" )
		Case $ctrlButtonCancel
			GUISetState( @SW_HIDE, $Gui_HA )
		Case $ctrlMenuEdit_NewSTP
			_NewSTP()
		Case $ctrlMenuEdit_NewHA
			_NewHA()
		Case $ctrlButtonOK
			Local $arrIni[5] = [ GUICtrlRead( $arrTry[0] ), GUICtrlRead( $arrTry[1] ), GUICtrlRead( $arrTry[2] ), GUICtrlRead( $arrTry[3] ) ]
			_WriteHAtoIni( $fIni, $arrIni, $ctrlListHA )
		Case $ctrlLinkGZE
			_OpenUrlInDefaultBrowser( "www.gze-ni.de" )
		Case $ctrlLinkVersion
			_OpenUrlInDefaultBrowser( "http://autoit.aufwaerts.de/thread.php?threadid=1144" )
		Case $ctrlMenuEdit_About
			_About()
		Case $ctrlMenuEdit_Exit
			Exit
		Case $GUI_EVENT_CLOSE
			If WinGetState( "Neue Hausaufgabe" ) = @SW_HIDE or WinActive( "Stundenplan" ) = 1 Then
				Exit
			Else
				GUISetState( @SW_HIDE, $Gui_HA )
			EndIf
	EndSwitch
	_UpdateHA( $ctrlLabelHAAufgabe, $ctrlLabelHAFach, $ctrlLabelHAVon, $ctrlLabelHABis )
WEnd